package de.mdelab.mlsdm.interpreter.debug.ui;

import java.io.IOException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.IEditorInput;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMDebuggerStoryDiagramEditor;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugSourceLocator;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugTarget;

public class MLSDMDebugSourceLocator extends SDDebugSourceLocator<MLElementWithUUID> {

	public MLSDMDebugSourceLocator(	final SDDebugTarget<MLElementWithUUID, Activity> p_target )	{
		super( p_target );
	}

	@Override
	public IEditorInput getEditorInput(	final Object p_element ) {
		assert p_element instanceof MLElementWithUUID;

		try {
			return getDebugTarget().getStoryDiagramEditorManager().getEditorInput( (MLElementWithUUID) p_element );
		} 
		catch ( final CoreException p_ex ) {
			throw new RuntimeException( p_ex );
		}
		catch ( final IOException p_ex ) {
			throw new RuntimeException( p_ex );
		}
	}

	@Override
	public String getEditorId(	final IEditorInput p_input,
								final Object p_element ) {
		return MLSDMDebuggerStoryDiagramEditor.ID;
	}
}
