package de.mdelab.mlsdm.interpreter.debug.ui.breakpoints;

import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.LabelEditPart;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.CreateDecoratorsOperation;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorProvider;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.IMLExpressionEditPart;

public class BreakpointDecoratorProvider extends AbstractProvider implements IDecoratorProvider {

	@Override
	public boolean provides( final IOperation p_operation ) {
		if ( p_operation instanceof CreateDecoratorsOperation ) {
			final IDecoratorTarget decoratorTarget = ( (CreateDecoratorsOperation) p_operation ).getDecoratorTarget();
			
			return shouldBeDecorated( decoratorTarget );
//			final EditPart editPart = (EditPart) decoratorTarget.getAdapter( EditPart.class );
//			
//			if (editPart instanceof AbstractGraphicalEditPart
//					&& (editPart instanceof IPrimaryEditPart || editPart instanceof CustomActivityEdgeGuardConstraintLabelEditPart
//							|| editPart instanceof StoryPatternStoryPatternConstraintsCompartmentEditPart
//							|| editPart instanceof StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart || editPart instanceof StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart))
//			{
//				final View view = (View) editPart.getModel();
//				final EObject element = view.getElement();
//				return 	element instanceof StoryNode || element instanceof StoryPatternObject || element instanceof ActivityEdge
//						|| element instanceof StoryPatternLink || element instanceof DecisionMergeNode
//						|| element instanceof InitialNode || element instanceof FlowFinalNode || element instanceof ActivityFinalNode
//						|| element instanceof ExpressionActivityNode || element instanceof MLStringExpression;
//			}
		}

		return false;

	}

	@Override
	public void createDecorators( final IDecoratorTarget p_decoratorTarget ) {
//		final EditPart editPart = (EditPart) p_decoratorTarget.getAdapter( EditPart.class );
//		final View view = (View) editPart.getModel();
//		final EObject element = view.getElement();
//		
//		System.out.println( editPart.getClass().getSimpleName() + " : " + element.eClass().getName() );

		
		if ( shouldBeDecorated( p_decoratorTarget ) ) {
//		
//		if (	editPart instanceof IPrimaryEditPart || editPart instanceof CustomActivityEdgeGuardConstraintLabelEditPart || 
//				editPart instanceof StoryPatternStoryPatternConstraintsCompartmentEditPart || editPart instanceof StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart ||
//				editPart instanceof StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart ||
//				editPart instanceof MLStringExpression2EditPart ) {
			final BreakpointDecorator decorator = new BreakpointDecorator( p_decoratorTarget );
			p_decoratorTarget.installDecorator( IMLSDMDebugUiBreakpointConstants.BREAKPOINT_DECORATOR, decorator );
		}
	}

	private boolean shouldBeDecorated( final IDecoratorTarget p_decoratorTarget ) {
		final EditPart editPart = (EditPart) p_decoratorTarget.getAdapter( EditPart.class );
		final MLElementWithUUID element;
		
		// Only decorate the semantic model parts and not the associated labels
		if ( editPart instanceof IMLExpressionEditPart ) {
			element = ( (IMLExpressionEditPart) editPart ).getMLExpression();
		}
		else if ( !( editPart instanceof LabelEditPart ) && !( editPart instanceof CompartmentEditPart ) ) {
			element =  (MLElementWithUUID) editPart.getAdapter( MLElementWithUUID.class );
		}
		else {
			element = null;
		}
		
		
		return 	element instanceof Activity || element instanceof ActivityNode || element instanceof StoryPatternObject ||
				element instanceof MLExpression || element instanceof StoryPatternLink || element instanceof StoryPattern ||
				element instanceof ActivityEdge;
	}
}
