package de.mdelab.mlsdm.interpreter.debug.ui.breakpoints;

import java.util.Arrays;

import org.eclipse.core.resources.IMarker;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.parts.IDiagramWorkbenchPart;
import org.eclipse.gmf.runtime.emf.ui.providers.marker.AbstractModelMarkerNavigationProvider;
import org.eclipse.ui.IEditorPart;

import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorUtil;
import de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMEditorManager;
import de.mdelab.sdm.interpreter.code.debug.ui.breakpoints.SDDebugBreakpoint;

public class MlsdmDebugMarkerNavigationProvider extends AbstractModelMarkerNavigationProvider {

	@Override
	protected void doGotoMarker( final IMarker p_marker ) {
		final String elementId = p_marker.getAttribute( SDDebugBreakpoint.ELEMENT_UUID, null );
		final IEditorPart part = getEditor();
		
		if ( elementId != null && part instanceof IDiagramWorkbenchPart ) {
			final IDiagramWorkbenchPart editor = (IDiagramWorkbenchPart) part;
			final EditPart targetEditPart = MLSDMEditorManager.findEditPart( editor, elementId );
				
			if ( targetEditPart != null ) {
				MlsdmDiagramEditorUtil.selectElementsInDiagram( editor, Arrays.asList(new EditPart[]{ targetEditPart } ) );
			}
		}
	}
}
