package de.mdelab.mlsdm.interpreter.debug.ui.launcher;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Composite;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.interpreter.debug.ui.launcher.table.MLSDMActivityParameterTableViewer;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.SDInterpreterLaunchMainTabDebug;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.SDActivityParameterTableViewer;

public class MLSDMInterpreterMainTabDebug extends SDInterpreterLaunchMainTabDebug<Activity> {

	@Override
	protected SDActivityParameterTableViewer<Activity, ?, ?> createActivityParameterTableViewer( final Composite p_parent ) {
		return new MLSDMActivityParameterTableViewer( p_parent );
	}

	@Override
	protected String getSDFileExtension() {
		return MLSDMInterpreterLaunchMainTab.SD_FILE_EXT;
	}

	@Override
	protected String getName( final Activity p_activity ) {
		assert p_activity != null;
		
		return p_activity.getName();
	}

	@Override
	protected boolean isActivity( final EObject p_object ) {
		return p_object instanceof Activity;
	}

	@Override
	protected boolean validateActivityParameters(
			ILaunchConfiguration p_configuration, Activity p_activity)
			throws CoreException {
		final String errMessage = MLSDMInterpreterLaunchMainTab.validateActivityParams( p_configuration, p_activity );
		
		if ( errMessage != null ) {
			setErrorMessage( errMessage );
			
			return false;
		}
		
		return true;
	}
}
