package de.mdelab.mlsdm.interpreter.debug.ui.launcher.table;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Composite;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.SDActivityParameterTableViewer;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.SDInstanceObjectEditingSupport;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.SDTableActivityParameterData;

/**
 * Table to edit story diagram activity parameters for Eclipse launch configuration
 */
public class MLSDMActivityParameterTableViewer extends SDActivityParameterTableViewer<Activity, ActivityParameter, EClassifier> {

	/**
	 * @param parent
	 */
	public MLSDMActivityParameterTableViewer( final Composite p_parent ) {
		super( p_parent );
	}

	@Override
	protected SDTableActivityParameterData<Activity> createTableActivityParameterData() {
		return new MLSDMTableActivityParameterData();
	}

	@Override
	protected SDInstanceObjectEditingSupport<EClassifier> createInstanceObjectsEditingSupport( 	final TableViewer p_tableViewer,
																								final ILabelProvider p_labelProvider ) {
		return new MLSDMInstanceObjectsEditingSupport( p_tableViewer, p_labelProvider );
	}
}