package de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor;


import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.ui.IMemento;

import de.mdelab.mlsdm.interpreter.debug.ui.IMLSDMDebugUiConstants;
import de.mdelab.resourceSetSynchronizer.SynchronizerAdapter;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugTarget;

public class MLSDMDebuggerEditorInput extends URIEditorInput {
	
	//public static final String	SERVER_PORT_TAG	= "serverPort";
	//public static final String	ACTIVITY_UUID	= "activityUUID";

	private final String activityUUID;

	private SynchronizerAdapter	synchronizerAdapter;

	//private EditingDomain		editingDomain;
	private final SDDebugTarget<?, ?> debugTarget;

	public MLSDMDebuggerEditorInput(	final URI p_uri,
										final SDDebugTarget<?, ?>  p_debugTarget,
										final String p_activityUUID ) {
		super( p_uri );

		debugTarget = p_debugTarget;
		activityUUID = p_activityUUID;
	}

	public MLSDMDebuggerEditorInput(IMemento memento) {
		super(memento);
		
		activityUUID = null;
		debugTarget = null;
	}

	@Override
	protected String getBundleSymbolicName() {
		return IMLSDMDebugUiConstants.PLUGIN_ID;
	}
//
//	@Override
//	protected void loadState(IMemento memento)
//	{
//		super.loadState(memento);
//	}
//
//	@Override
//	public void saveState(IMemento memento)
//	{
//		super.saveState(memento);
//	}

	public SynchronizerAdapter getSynchronizerAdapter()
	{
		return this.synchronizerAdapter;
	}

	public void setSynchronizerAdapter(SynchronizerAdapter synchronizerAdapter)
	{
		this.synchronizerAdapter = synchronizerAdapter;
	}

	public String getActivityUUID()
	{
		return this.activityUUID;
	}

	public EditingDomain getEditingDomain()	{
		//return this.editingDomain;
		return debugTarget == null ? null : debugTarget.getDebuggerEditingDomain();
	}
//
//	public void setEditingDomain(EditingDomain editingDomain) {
//		if ( this.editingDomain = editingDomain;
//	}

	public SDDebugTarget<?, ?> getDebugTarget() {
		return debugTarget;
	}
}
